#include <stdio.h>
#include <stdlib.h>

struct node {
  int value;
  struct node *p[2];
  int visited;
};

struct graph {
  struct node *root;
};

struct node *new_node(int value, struct node *p0, struct node *p1)
{
  struct node *n = malloc(sizeof(struct node));
  n->value = value;
  n->p[0] = p0;
  n->p[1] = p1;
  n->visited = 0;
  return n;
}



void clear_visited(struct node *n)
{
  if (n != NULL) {
    n->visited = 0;
    clear_visited(n->p[0]);
    clear_visited(n->p[1]);
  }
}

void print_aux(struct node *n)
{
  if ((n != NULL) && (n->visited == 0)) {
    printf("%d ", n->value);
    n->visited = 1;
    print_aux(n->p[0]);
    print_aux(n->p[1]);
  }
}

void print(struct graph *g)
{
  print_aux(g->root);
  printf("\n");
  clear_visited(g->root);
}



struct cell {
  struct node *n;
  struct cell *next;
};

struct list {
  struct cell *first;
};

void push(struct list *l, struct node *n)
{
  struct cell *c;

  c = malloc(sizeof(struct cell));

  c->n = n;
  c->next = l->first;

  l->first = c;
}

struct node *pop(struct list *l)
{
  struct cell *c;
  struct node *n;

  if (l->first == NULL) {
    printf("pop d'une liste vide.\n");
    abort();
  }

  c = l->first;
  n = c->n;
  l->first = c->next;
  free(c);

  return n;
}

void free_graph(struct graph *g)
{
  struct list l = { NULL };
  struct list s = { NULL };

  push(&s, g->root);
  while (s.first != NULL) {
    struct node *n = pop(&s);
    struct cell *c;

    for (c = l.first; c != NULL; c = c->next) {
      if (c->n == n)
	break;
    }

    if (c == NULL) {
      printf("On libre %d.\n", n->value);
      push(&l, n);
      if (n->p[0])
	push(&s, n->p[0]);
      if (n->p[1])
	push(&s, n->p[1]);
      free(n);
    }
  }
}



int main()
{
  struct graph g;
  struct node *n1, *n2, *n3, *n4;

  n4 = new_node(7, NULL, NULL);
  n2 = new_node(2, n4,   NULL);
  n3 = new_node(1, n4,   NULL);
  n1 = new_node(4, n2,   n3  );
  g.root = n1;

  print(&g);
  print(&g);
  free_graph(&g);

  return 0;
}
