#include <stdio.h>
#include <stdlib.h>

struct cell {
  int value;
  struct cell *next;
};

struct list {
  struct cell *first;
};

void push(struct list *l, int value)
{
  struct cell *c;

  c = malloc(sizeof(struct cell));

  c->value = value;
  c->next = l->first;

  l->first = c;
}

/**/
/**/
/**/
/* Insrez vos fonctions ici. */
/**/
/**/
/**/
void print(struct list *l)
{
  struct cell *c;

  printf("[");
  for (c = l->first; c != NULL; c = c->next) {
    printf("%d", c->value);
    if (c->next != NULL)
      printf(", ");
  }
  printf("]\n");
}

int pop(struct list *l)
{
  struct cell *c;
  int value;

  if (l->first == NULL) {
    printf("pop d'une liste vide.\n");
    abort();
  }

  c = l->first;
  value = c->value;
  l->first = c->next;
  free(c);

  return value;
}

void reverse(struct list *l)
{
  struct cell *c, *prev, *next;

  for (c = l->first, prev = NULL; c != NULL; c = next) {
    next = c->next;
    c->next = prev;
    prev = c;
  }
  l->first = prev;
}

void split(int x, struct list *l, struct list *l1, struct list *l2)
{
  struct cell *c, *last1, *last2, *next;

  last1 = l1->first = NULL;
  last2 = l2->first = NULL;

  for (c = l->first; c != NULL; c = next) {
    struct list *li = (c->value <= x) ? l1 : l2;
    struct cell **last = (c->value <= x) ? &last1 : &last2;

    next = c->next;
    c->next = NULL;

    if (*last != NULL)
      (*last)->next = c;
    *last = c;

    if (li->first == NULL)
      li->first = c;
  }
  l->first = NULL;
}

void append(struct list *l1, struct list *l2, struct list *l)
{
  struct cell *c;

  if (l1->first != NULL) {
    l->first = l1->first;
    for (c = l1->first; c->next != NULL; c = c->next);
    c->next = l2->first;
  }
  else
    l->first = l2->first;
}

void quick_sort(struct list *l)
{
  if (l->first != NULL) {
    struct cell *c;
    struct list l1, l2;

    c = l->first;
    l->first = l->first->next;
    split(c->value, l, &l1, &l2);

    quick_sort(&l1);
    quick_sort(&l2);

    c->next = l2.first;
    l2.first = c;
    append(&l1, &l2, l);
  }
}

int main()
{
  struct list l = { NULL };

  push(&l, 4);
  push(&l, 6);
  push(&l, 1);
  push(&l, 2);
  push(&l, 8);
  push(&l, 7);
  push(&l, 0);
  push(&l, 5);
  push(&l, 3);
  push(&l, 9);

  print(&l);
  quick_sort(&l);
  print(&l);

  return 0;
}
